#!/bin/bash
#
# Gestures install 
# version 1.5
# 
# by The Fan Club 2021
#
# NOTE: run as SUDO
#
#
# Remove if selected 
if [ "$1" = "--remove" ]; then 
	echo "[Gestures] Gestures uninstall started..."
	python3 -m pip uninstall gestures 2>/dev/null
	rm /usr/local/bin/gestures 2>/dev/null
	rm /usr/bin/gestures 2>/dev/null
	rm -r /usr/share/gestures 2>/dev/null
	rm /usr/share/applications/org.cunidev.gestures.desktop 2>/dev/null
	rm /usr/share/applications/com.gitlab.cunidev.Gestures.desktop
	rm /usr/share/metainfo/org.cunidev.gestures.appdata.xml 2>/dev/null
	rm /usr/share/icons/hicolor/scalable/apps/org.cunidev.gestures.svg 2>/dev/null
	rm /home/$SUDO_USER/.config/autostart/org.cunidev.gestures.desktop 2>/dev/null
	rm /home/$SUDO_USER/.config/autostart/com.gitlab.cunidev.Gestures.desktop
	rm /usr/share/appdata/com.gitlab.cunidev.Gestures.appdata.xml
	rm /usr/share/glib-2.0/schemas/com.gitlab.cunidev.Gestures.gschema.xml
	rm /usr/share/icons/hicolor/scalable/apps/com.gitlab.cunidev.Gestures.svg

	# remove libinput-gestures
	su $SUDO_USER libinput-gestures-setup stop 2>/dev/null
	su $SUDO_USER libinput-gestures-setup autostop 2>/dev/null
	libinput-gestures-setup uninstall 2>/dev/null
	echo "[Gestures] Gestures removal complete."
	exit 
fi
#
# Install libinput-gestures - https://github.com/bulletmark/libinput-gestures
echo "[Gestures] Gestures install started..."
#
# Add user to input group
gpasswd -a $SUDO_USER input
echo "[Gestures] $SUDO_USER added to input user group"
# Install prerequisites
echo "[Gestures] Install all depedencies"
apt-get install xdotool wmctrl libinput-tools python3 python3-setuptools python3-gi python-gobject gettext meson git 
# Install/Update
if [ -d libinput-gestures ]; then
	rm -r libinput-gestures 
fi
echo "[Gestures] Downloading libinput-gestures from GitHub..."
git clone https://github.com/bulletmark/libinput-gestures.git
cd libinput-gestures
make install
cd ..
echo "[Gestures] libinput-gestures installed"
#
# Install Gestures - https://gitlab.com/cunidev/gestures
#
# Install 
if [ -d gestures ]; then
	rm -r gestures 
fi
echo "[Gestures] Downloading Gestures from GitLab..."
git clone https://gitlab.com/cunidev/gestures
cd gestures
meson build --prefix=/usr
ninja -C build
sudo ninja -C build install
# Cleanup
cd ..
rm -r gestures 
rm -r libinput-gestures 
echo "[Gestures] Gestures installation complete"
sudo sed -i 's/Gtk\.CssProvider(/Gtk\.CssProvider.get_default(/g' /usr/share/gestures/gestures/app.py
sudo sed -i 's/css_provider.load_from_data/#css_provider.load_from_data/g' /usr/share/gestures/gestures/app.py
echo "[Gestures] Fixed the CSS display issue if still present - see https://gitlab.com/aviyam/gestures/-/merge_requests/1/diffs"
# Autostart libinput-gestures at boot and start now for current user
su $SUDO_USER libinput-gestures-setup stop
su $SUDO_USER libinput-gestures-setup autostart
su $SUDO_USER libinput-gestures-setup start
echo "[Gestures] libinput-gestures started for $SUDO_USER"
# Autostart Gestures 
cp /usr/share/applications/com.gitlab.cunidev.Gestures.desktop /home/$SUDO_USER/.config/autostart/
sed -i 's/=gestures/=gestures\&/g' /home/$SUDO_USER/.config/autostart/com.gitlab.cunidev.Gestures.desktop
chown $SUDO_USER:$SUDO_USER /home/$SUDO_USER/.config/autostart/com.gitlab.cunidev.Gestures.desktop
echo
echo "[Gestures] Reboot to complete the installation"